﻿#SingleInstance, Force	
#WinActivateForce			
SetBatchLines, -1	



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sourceSentence := "When I fond myslf in times of Troouble"
targetSentence := "When I find myself in times of trouble"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



SoundBeep, 2222, 55
SoundBeep, 2222, 55

Global collectionNotChanged := []						
Global collectionDeleted := []	
Global collectionAdded := []	
Global collectionFinal := []	
Global collectionFinalAggCharacterLevel
Global collectionFinalAggWordLevel

GUI, myMainGUI: New, +AlwaysOnTop, % "      Simple test... "  
GUI, myMainGUI: Add, Text, y+15, 1st Sentence  :
GUI, myMainGUI: Add, Edit, x+7 yp-3 w410 vUpperSentence, % sourceSentence
GUI, myMainGUI: Add, Text, xm, 2nd Sentence :
GUI, myMainGUI: Add, Edit, x+7 yp-3 w410 vLowerSentence, % targetSentence
GUI, myMainGUI: Add, Text, x70 y70  vmyDisplayPart , % "                   "    			
GUI, myMainGUI: Add, Button, x103 yp w410 h28 -Tabstop Default gMyButton, Track changes  (Click/Enter)
GUI, myMainGUI: Show, w650 h110 x655 y405
GUIControl, myMainGUI: Focus, LowerSentence
Send, {End}
Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MyButton:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SoundBeep, 5555, 55
SoundBeep, 6666, 55
SoundBeep, 7777, 55
GUI, myMainGUI: Submit, NoHide
GUI, myMainGUI2: Destroy
GUI, myMainGUI2: New, +Resize +AlwaysOnTop, % "      Simple result... "  
presentCharacterLevelTrackChanges(UpperSentence, LowerSentence)
presentWordLevelTrackChanges(UpperSentence, LowerSentence)
textPresentationCodeByManYakAee(40, 12, "`n<s15>"  collectionFinalAggCharacterLevel "`n`n" collectionFinalAggWordLevel) 
GUI, myMainGUI2: Show, w650 h120 x650 y550
GUI, myMainGUI2: Color, Black
Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
myMainGUIGUIClose:
myMainGUIGUIEscape:
myMainGUI2GUIClose:
myMainGUI2GUIEscape:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SoundBeep, 333, 123
GUI, myMainGUI: Destroy
GUI, myMainGUI2: Destroy
ExitApp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
presentCharacterLevelTrackChanges(deliverySentence, reviewSentence)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	collectionNotChanged := []						
	collectionDeleted := []	
	collectionAdded := []	
	collectionFinal := []	
	collectionFinalAggCharacterLevel := ""
	
	compareItByCharacter(0, deliverySentence, reviewSentence)
	collectionNotChanged := arraySortByNumber(collectionNotChanged)
			
	flagNothing := False
	If(collectionNotChanged.Length() = 0)
		flagNothing := True
		
	previousItemLastPoint := 0	            																	
	deletedContent := ""

	For myIndex, myItem In collectionNotChanged						
	{
		thisItem := StrSplit(myItem, "^_^") 
		
		thisItemStartPoint := thisItem[1]
		thisItemLength := StrLen(thisItem[2])
		
		deletedContent := SubStr(deliverySentence, previousItemLastPoint + 1, thisItemStartPoint - previousItemLastPoint )

		If(deletedContent = "")
			collectionDeleted.Push("0" "^_^" "")															
		Else
			collectionDeleted.Push(previousItemLastPoint "^_^" deletedContent)

		previousItemLastPoint := thisItemStartPoint + thisItemLength

		If(myIndex = collectionNotChanged.SetCapacity(0))											
		{
			If(previousItemLastPoint > StrLen(deliverySentence))														
				collectionDeleted.Push(previousItemLastPoint "^_^" "")
			Else
				collectionDeleted.Push(previousItemLastPoint "^_^" SubStr(deliverySentence, previousItemLastPoint + 1))	
		}
	}

	collectionNotChanged := []	
	compareItByCharacter(0, reviewSentence, deliverySentence)
	collectionNotChanged := arraySortByNumber(collectionNotChanged)

	For Each, myItem In collectionNotChanged																	
		collectionFinal.Push(myItem)

	previousItemLastPoint := 0									;  													
	addedContent := ""

	For myIndex, myItem In collectionNotChanged	
	{
		thisItem := StrSplit(myItem, "^_^") 
		
		thisItemStartPoint := thisItem[1]
		thisItemLength := StrLen(thisItem[2])
		
		addedContent := SubStr(reviewSentence, previousItemLastPoint + 1, thisItemStartPoint - previousItemLastPoint)

		If(addedContent = "")
			collectionAdded.Push("0" "^_^" "")														
		Else
		{
			collectionAdded.Push(previousItemLastPoint "^_^" addedContent)
			collectionFinal.Push(previousItemLastPoint "^_^" addedContent "^_^" "<Norm cAqua Underline Bold>")     	          
		}
		
		previousItemLastPoint := thisItemStartPoint + thisItemLength

		If(myIndex = collectionNotChanged.SetCapacity(0))							
		{
				If(previousItemLastPoint > StrLen(reviewSentence))										
					collectionAdded.Push(previousItemLastPoint "^_^" "")
				Else
				{
					collectionAdded.Push(previousItemLastPoint "^_^" SubStr(reviewSentence, previousItemLastPoint + 1))
					collectionFinal.Push(previousItemLastPoint "^_^" SubStr(reviewSentence, previousItemLastPoint + 1) "^_^" "<Norm cAqua Underline Bold>")		
				}
		}	
	}

	collectionNotChanged := arraySortReverse(collectionNotChanged)
	collectionDeleted := arraySortReverse(collectionDeleted)
	collectionAdded := arraySortReverse(collectionAdded)

	deletedPoint := 0
	deletedContent := ""
	deletedLength := 0
	deletionInjectPoint := 0
	addedContent := ""
	addedLength := 0

	For myIndex, myItem In collectionDeleted	
	{
		thisItem := StrSplit(myItem, "^_^") 
		
		deletedContent := thisItem[2]
		deletedLength := StrLen(deletedContent)
		
		If(deletedContent = "")
			Continue
					
		If(myIndex = 1)
			deletionInjectPoint := StrLen(reviewSentence)       
		Else
			deletionInjectPoint := StrSplit(collectionNotChanged[myIndex - 1], "^_^")[1] 

		addedContent := StrSplit(collectionAdded[myIndex], "^_^")[2]
		addedLength := StrLen(addedContent) 

		If(addedContent ~= "^ ")
			deletionInjectPoint -= addedLength 
		
		For x, y In collectionFinal	
			If(deletionInjectPoint <= StrSplit(y, "^_^")[1])
				collectionFinal[x] := deletedLength + StrSplit(y, "^_^")[1] "^_^" StrSplit(y, "^_^")[2] "^_^" StrSplit(y, "^_^")[3]  

		collectionFinal.Push(deletionInjectPoint "^_^" deletedContent "^_^" "<Norm cRed Strike Bold>" )              	
	}
	
	If(flagNothing)
	{
		collectionFinal.Push(0 "^_^" reviewSentence "^_^" "<Norm cAqua Underline Bold>")
		collectionFinal.Push(StrLen(reviewSentence) "^_^" deliverySentence "^_^" "<Norm cRed Strike Bold>")
	}

	collectionFinal := arraySortByNumber(collectionFinal)

	For Each, myItem In collectionFinal				
	{
		myResults := StrSplit(myItem, "^_^") 
		collectionFinalAggCharacterLevel .= myResults[3] myResults[2] 
	}
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
presentWordLevelTrackChanges(deliverySentence, reviewSentence)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	collectionNotChanged := []						
	collectionDeleted := []	
	collectionAdded := []	
	collectionFinal := []	
	collectionFinalAggWordLevel := ""
	
	compareItByWord(0, deliverySentence, reviewSentence)
	collectionNotChanged := arraySortByNumber(collectionNotChanged)
			
	flagNothing := False
	If(collectionNotChanged.Length() = 0)
		flagNothing := True
		
	previousItemLastPoint := 0	            																	
	deletedContent := ""

	For myIndex, myItem In collectionNotChanged			
	{
		thisItem := StrSplit(myItem, "^_^") 
		
		thisItemStartPoint := thisItem[1]
		thisItemLength := StrLen(thisItem[2])
		
		deletedContent := SubStr(deliverySentence, previousItemLastPoint + 1, thisItemStartPoint - previousItemLastPoint )

		If(deletedContent = "")
			collectionDeleted.Push("0" "^_^" "")														
		Else
			collectionDeleted.Push(previousItemLastPoint "^_^" deletedContent)

		previousItemLastPoint := thisItemStartPoint + thisItemLength

		If(myIndex = collectionNotChanged.SetCapacity(0))											
		{
			If(previousItemLastPoint > StrLen(deliverySentence))														
				collectionDeleted.Push(previousItemLastPoint "^_^" "")
			Else
				collectionDeleted.Push(previousItemLastPoint "^_^" SubStr(deliverySentence, previousItemLastPoint + 1))	
		}
	}

	collectionNotChanged := []	
	compareItByWord(0, reviewSentence, deliverySentence)
	collectionNotChanged := arraySortByNumber(collectionNotChanged)

	For Each, myItem In collectionNotChanged													
		collectionFinal.Push(myItem)

	previousItemLastPoint := 0									;  													
	addedContent := ""

	For myIndex, myItem In collectionNotChanged	
	{
		thisItem := StrSplit(myItem, "^_^") 
		
		thisItemStartPoint := thisItem[1]
		thisItemLength := StrLen(thisItem[2])
		
		addedContent := SubStr(reviewSentence, previousItemLastPoint + 1, thisItemStartPoint - previousItemLastPoint)

		If(addedContent = "")
			collectionAdded.Push("0" "^_^" "")																
		Else
		{
			collectionAdded.Push(previousItemLastPoint "^_^" addedContent)
			collectionFinal.Push(previousItemLastPoint "^_^" addedContent "^_^" "<Norm cAqua Underline Bold>")     	          
		}
		
		previousItemLastPoint := thisItemStartPoint + thisItemLength

		If(myIndex = collectionNotChanged.SetCapacity(0))							
		{
				If(previousItemLastPoint > StrLen(reviewSentence))										
					collectionAdded.Push(previousItemLastPoint "^_^" "")
				Else
				{
					collectionAdded.Push(previousItemLastPoint "^_^" SubStr(reviewSentence, previousItemLastPoint + 1))
					collectionFinal.Push(previousItemLastPoint "^_^" SubStr(reviewSentence, previousItemLastPoint + 1) "^_^" "<Norm cAqua Underline Bold>")
				}
		}	
	}

	collectionNotChanged := arraySortReverse(collectionNotChanged)
	collectionDeleted := arraySortReverse(collectionDeleted)
	collectionAdded := arraySortReverse(collectionAdded)

	deletedPoint := 0
	deletedContent := ""
	deletedLength := 0
	deletionInjectPoint := 0
	addedContent := ""
	addedLength := 0

	For myIndex, myItem In collectionDeleted	
	{
		thisItem := StrSplit(myItem, "^_^") 
		
		deletedContent := thisItem[2]
		deletedLength := StrLen(deletedContent)
		
		If(deletedContent = "")
			Continue
					
		If(myIndex = 1)
			deletionInjectPoint := StrLen(reviewSentence)       
		Else
			deletionInjectPoint := StrSplit(collectionNotChanged[myIndex - 1], "^_^")[1] 

		addedContent := StrSplit(collectionAdded[myIndex], "^_^")[2]
		addedLength := StrLen(addedContent) 

		If(addedContent ~= "^ ")
			deletionInjectPoint -= addedLength 
		
		For x, y In collectionFinal	
			If(deletionInjectPoint <= StrSplit(y, "^_^")[1])
				collectionFinal[x] := deletedLength + StrSplit(y, "^_^")[1] "^_^" StrSplit(y, "^_^")[2] "^_^" StrSplit(y, "^_^")[3]    	

		collectionFinal.Push(deletionInjectPoint "^_^" deletedContent "^_^" "<Norm cRed Strike Bold>" )              		
	}
	
	If(flagNothing)
	{
		collectionFinal.Push(0 "^_^" reviewSentence "^_^" "<Norm cAqua Underline Bold>")
		collectionFinal.Push(StrLen(reviewSentence) "^_^" deliverySentence "^_^" "<Norm cRed Strike Bold>")
	}

	collectionFinal := arraySortByNumber(collectionFinal)

	For Each, myItem In collectionFinal				
	{
		myResults := StrSplit(myItem, "^_^") 
		collectionFinalAggWordLevel .= myResults[3] myResults[2] 
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
compareItByCharacter(myOffset, myDeliveryContent, myReviewContent)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	deliveryHead := ""
	deliveryTail := ""
	reviewHead := ""
	reviewTail := ""
	
	myResults := StrSplit(LCScharacterLevel(myDeliveryContent, myReviewContent), "^_^")      	
	
	If(myResults.SetCapacity(0) > 0)														 
	{
		deliveryIndex := myResults[1]
		reviewIndex := myResults[2]
		commonLength := myResults[3]
		commonContent := myResults[4]	
		collectionNotChanged.Push(myOffset + deliveryIndex "^_^" commonContent "^_^" "<Norm cWhite Bold>")    	
		If(deliveryIndex <> 0)
		{
			deliveryHead := SubStr(myDeliveryContent, 1, deliveryIndex)								
			reviewHead := SubStr(myReviewContent, 1, reviewIndex)
			compareItByCharacter(myOffset, deliveryHead, reviewHead)		
		}
		If(deliveryIndex + commonLength < StrLen(myDeliveryContent))
		{
			deliveryTail := SubStr(myDeliveryContent, deliveryIndex + commonLength + 1)			
			reviewTail := SubStr(myReviewContent, reviewIndex + commonLength + 1)
			compareItByCharacter(myOffset + deliveryIndex + commonLength, deliveryTail, reviewTail)		
		}
	}
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LCScharacterLevel(a, b)																		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
{
;  Longest Common Substring																
;  https://rosettacode.org/wiki/Longest_common_substring#AutoHotkey

	StringCaseSense, On																				
	x := i := 0																							
	While StrLen(x)	
		Loop, % StrLen(a)
			IfInString, b, % x := SubStr(a, i := StrLen(x) = 1 ? i + 1 : i, n := StrLen(a) + 1 - A_Index)
			{
				If(myReturn == x)					
					Continue	
				If(StrLen(myReturn) > StrLen(x))
					Continue
				If(StrLen(myReturn) = StrLen(x))
					If(myReturn < x) 			
						Continue	
				myReturn := x 					
			}
	If(myReturn = "")																							
		Return
	Return InStr(a, myReturn) - 1 "^_^" InStr(b, myReturn) - 1 "^_^" StrLen(myReturn) "^_^" myReturn    
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
compareItByWord(myOffset, myDeliveryContent, myReviewContent)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	deliveryHead := ""
	deliveryTail := ""
	reviewHead := ""
	reviewTail := ""
	
	myResults := StrSplit(LCSwordLevel(myDeliveryContent, myReviewContent), "^_^")   
  	
	If(myResults.SetCapacity(0) > 0)														 	
	{
		deliveryIndex := myResults[1]
		reviewIndex := myResults[2]
		commonLength := myResults[3]
		commonContent := myResults[4]	
		collectionNotChanged.Push(myOffset + deliveryIndex "^_^" commonContent "^_^" "<Norm cWhite Bold>")    
		If(deliveryIndex <> 0)
		{
			deliveryHead := SubStr(myDeliveryContent, 1, deliveryIndex)								
			reviewHead := SubStr(myReviewContent, 1, reviewIndex)
			compareItByWord(myOffset, deliveryHead, reviewHead)		
		}
		If(deliveryIndex + commonLength < StrLen(myDeliveryContent))
		{
			deliveryTail := SubStr(myDeliveryContent, deliveryIndex + commonLength + 1)			
			reviewTail := SubStr(myReviewContent, reviewIndex + commonLength + 1)
			compareItByWord(myOffset + deliveryIndex + commonLength, deliveryTail, reviewTail)		
		}
	}
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
LCSwordLevel(a, b)																
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
{
	myDeliveryWordArray := []
	myReviewWordArray := []	
	myTempWordArray := [""]	
	
	regExpPattern := "(\w+)|( +)|([^\w ]+)"
	
	While @ := RegExMatch(a, regExpPattern, _, @ ? StrLen(_) + @ : 1)    	
		myDeliveryWordArray.Push(_)
	While @ := RegExMatch(b, regExpPattern, _, @ ? StrLen(_) + @ : 1)    	
		myReviewWordArray.Push(_)
		
	reviewArrayLength := myReviewWordArray.Length()
	StringCaseSense, On				
	startAT := 0		
	
	While myTempWordArray.Length()
	{
		Loop % myDeliveryWordArray.Length()
		{
			If(A_Index + myIndex - 1  = myDeliveryWordArray.Length()) 
				Break
			startAT := myTempWordArray.Length() = 1 ? startAT + 1 : startAT
			myLength := A_Index
			myTempWordArray := myDeliveryWordArray.Clone()
			Loop, % startAT - 1
				myTempWordArray.RemoveAt(1)
			Loop, % myLength - 1
				myTempWordArray.RemoveAt(myTempWordArray.Length())
			stringTemp := ""
			For Each, x In myTempWordArray
				stringTemp .= x
			If(myReturn == stringTemp)						
				Continue	
			If(StrLen(myReturn) > StrLen(stringTemp))	
				Continue
			If(StrLen(myReturn) = StrLen(stringTemp))	 
				If(myReturn < stringTemp) 			
					Continue							
			tempArrayLength := myTempWordArray.Length()			
			If(tempArrayLength > reviewArrayLength)							
				Continue
			copyOfReviewArray := myReviewWordArray.Clone()
			myLoopCount := reviewArrayLength - tempArrayLength + 1
			Loop, % myLoopCount
			{
				If(A_Index > 1)								
					copyOfReviewArray.RemoveAt(1)				
				myPerformance := 0
				Loop, % tempArrayLength								
					If(copyOfReviewArray[A_Index] == myTempWordArray[A_Index])		
						myPerformance++
				If(tempArrayLength = myPerformance)   										
					myReturn := stringTemp
			}	
		}
		myIndex ++
	}
	If(myReturn = "")																							
		Return
	Return InStr(a, myReturn) - 1 "^_^" InStr(b, myReturn) - 1 "^_^" StrLen(myReturn) "^_^" myReturn    
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
arraySortByNumber(arrayArgument)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	For Each, myItem In arrayArgument						
		arrayAggr .= myItem "`n" 
	Sort, arrayAggr, N									
	arrayArgument := []											
	Loop, Parse, arrayAggr, `n, `r					 	
		If(A_LoopField)
			arrayArgument.Push(A_LoopField)			 	
	Return arrayArgument
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
arraySortReverse(arrayArgument)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	For Each, myItem In arrayArgument						
		arrayAggr := myItem "`n" arrayAggr 
	arrayArgument := []										
	Loop, Parse, arrayAggr, `n, `r					
		If(A_LoopField)
			arrayArgument.Push(A_LoopField)					
	Return arrayArgument
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
textPresentationCodeByManYakAee(X, Y, Z) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	H := RegExReplace(">`n<>" Z "<", "\r\n|\r", "`n") 			
	While P := RegExMatch(H, "U)(<.*>|>.*<)", R, P ? ++P : 1) 
		If RegExMatch(R, "<(?:(.*),\s*(.*)\s*|(.*))>", C) 				
			GUI, myMainGUI2: Font, % C1 ? C1 : C3, % C2 
		Else If RegExMatch(R, ">(.+)<", C) 							
		{
			StringSplit, A, C1, `n 
			Loop, % A0 														
				GUI, myMainGUI2: Add, Text, % A_Index = 1 ? "x+ yp" : "x" X " y" (P = 1 ? Y : "+") (A%A_Index% ? "" : " w0 r1"), % A%A_Index% 
		} 
}
